<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\NewCode;
use Teknisa\SM\Service\Sm00006000RelacElementoService;

class Sm00006000RelacElementoController extends SMCrud
{
    protected $dataSourceName = 'fct_relacservico_widget';
    protected $newCode;
    protected $ServiceRelacElemento;

    public function __construct($crudService, $environment, NewCode $newCode, Sm00006000RelacElementoService $ServiceRelacServico) {
        parent::__construct($crudService, $environment);
        $this->newCode = $newCode;
        $this->ServiceRelacElemento = $ServiceRelacElemento;
    }
    
    /**
     * A função "validaServicoRelacionado" verifica se o serviço 
     * que está sendo relacionado já existe está relacionadoao serviço.
     */
    
    public function validaServicoRelacionado(Request\Row $request, Response $response) {
    
        $row = $request->getRow();
        
        $servOrcaRelac = $row['CDSERVORCARELAC']; 
        $servOrca = $row['CDSERVORCA']; 
        $tipoMedida = $row['CDTPMEDIDASERV'];
        
        $ValidaServRelac = $this->ServiceRelacElemento->validaServicoRelacionado($servOrcaRelac, $servOrca, $tipoMedida);
        
        $dtsValServRelac = new DataSet('VALIDASERV', array('VALIDA'=>$ValidaServRelac));
        
        $response->addDataSet($dtsValServRelac);
    
    }    
    
    public function save(Request $request, Response $response) {
        
        $rows = $request->getDataSet()->getRows();
        
        foreach($rows as $row) {
            if ($row["__is_new"]) {
                
                $row['NRRELACSERVICO'] = $this->newCode->getCodeByTableName("FCT_RELACSERVICO", $this->environment->getNrOrg());
                
            }    
        }
        
        $request->setParameter('dbname', 'fct_relacservico_widget');
        parent::save($request, $response);
        
    }
    
    public function delete(Request $request, Response $response) {
    
        $request->setParameter('dbname', 'fct_relacservico_widget');
        parent::delete($request, $response);
    
    }
    
    public function find(Request\Filter $request, Response $response) {
    
        $request->setParameter('dbname', 'fct_relacservico_widget');
        parent::find($request, $response);
    
    }
    
}
?>