/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_TPOCORINFU                                               */
/* Tabela : TPOCORINFU                                                        */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TPOCORINFU'  and
            type = 'TR'                       and
            u.uid = o.uid                     and
            u.name = USER)
  DROP TRIGGER DTULTATU_TPOCORINFU
  GO

CREATE TRIGGER DTULTATU_TPOCORINFU
ON TPOCORINFU
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'TPOCORINFU', NULL, 'CDTPOCORINFU='+CDTPOCORINFU+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TPOCORINFU
      SET DTULTATUTPOI = GETDATE()
      FROM INSERTED
      WHERE
         (TPOCORINFU.CDTPOCORINFU = INSERTED.CDTPOCORINFU)
   END;
END;
GO
