IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'TRAB_RELCARDMES' AND
                 TYPE = 'P' 		    AND
                 U.UID = O.UID              AND
                 U.NAME = USER)
DROP PROCEDURE TRAB_RELCARDMES
GO
CREATE PROCEDURE TRAB_RELCARDMES
(  @P_NRSEQTRABCARD VARCHAR(10),
   @P_NRLISTASERV   VARCHAR(10),
   @P_DTMESINIC     DATETIME,
   @P_DTMESFIM      DATETIME,
   @P_IDNOMEFANT    VARCHAR(01),
   @P_IDIMPDIASSEM  VARCHAR(01),
   @P_QTCOLUNA      FLOAT
)
 AS
   DECLARE @V_CONT            FLOAT;
   DECLARE @V_PAGINA          FLOAT;
   DECLARE @V_CDPRATO         VARCHAR(10);
   DECLARE @V_CDFILAUXPRAT    VARCHAR(04);
   DECLARE @V_QTCOMENSAIS     FLOAT;
   DECLARE @V_VRPECONSCARD    FLOAT;
   DECLARE @V_NMPRATO         VARCHAR(40);
   DECLARE @V_CDDIETPAD       VARCHAR(04);
   DECLARE @V_ROW             FLOAT;
   DECLARE @V_CDFILISERV      VARCHAR(09);

/* VARIAVEIS DO CURSOR C_SERVICO */
   DECLARE @V_CDFILIAL        VARCHAR(04);
   DECLARE @V_CDSERVFILI      VARCHAR(05);
   DECLARE @V_DTMES           DATETIME;
   DECLARE @V_SER_CDDIETPAD   VARCHAR(04);

/* VARIAVEIS DO CURSOR C_CONFIG */
   DECLARE @V_CONF_CDFILIAL   VARCHAR(04);
   DECLARE @V_CONF_CDSERVFILI VARCHAR(05);
   DECLARE @V_DTREFECNFMES    DATETIME;
   DECLARE @V_NRSEQCNFMES     FLOAT;
   DECLARE @V_NRORDCNFMES     FLOAT;
   DECLARE @V_CDTIPOPRAT      VARCHAR(02);
   DECLARE @V_IDOPCCNFMES     VARCHAR(01);
   DECLARE @V_NMTIPOPRAT      VARCHAR(15);

/* VARIAVEIS DO CURSOR C_DATA */
   DECLARE @V_DTDATA          DATETIME;
   DECLARE @V_DATA_DTMES      DATETIME;   

BEGIN
   SET @V_CDFILISERV = '';
   
   /* SELECIONA OS SERVICOS E SUAS DIETAS PADROES CASO EXISTAM */
   DECLARE C_SERVICO CURSOR FOR  
     SELECT SE.CDFILIAL, SE.CDSERVFILI, DT.DTMES, DI.CDDIETPAD
         FROM SERVICO SE LEFT JOIN (SELECT CA.CDFILIAL, CA.CDSERVFILI, CA.CDDIETPAD
                                     FROM DIETSERV DS LEFT JOIN CARDADIA CA 
                                                                 ON (CA.CDFILIAL   = DS.CDFILIAL
                                                                   AND CA.CDSERVFILI = DS.CDSERVFILI
                                                                   AND CA.CDDIETPAD  = DS.CDDIETPAD)
                                                                           , (SELECT SUBSTRING(CDLISTA, 1, 4) AS CDFILIAL,
                                                                                     SUBSTRING(CDLISTA, 5, 5) AS CDSERVFILI
                                                                               FROM LISTA
                                                                               WHERE NRLISTA = @P_NRLISTASERV) LA
                                  WHERE DS.CDFILIAL   = CA.CDFILIAL       
                                    AND DS.CDSERVFILI = CA.CDSERVFILI
                                    AND CA.CDFILIAL   = LA.CDFILIAL
                                    AND CA.CDSERVFILI = LA.CDSERVFILI
                                    AND CA.DTCARDAPIO BETWEEN @P_DTMESINIC AND @P_DTMESFIM
                                            )DI ON (SE.CDSERVFILI = DI.CDSERVFILI) AND
                                                (SE.CDFILIAL = DI.CDFILIAL),
                                (SELECT SUBSTRING(CDLISTA, 1, 4) AS CDFILIAL,
                                        SUBSTRING(CDLISTA, 5, 5) AS CDSERVFILI
                                   FROM LISTA
                                  WHERE NRLISTA = @P_NRLISTASERV) LS, 
                                (SELECT DISTINCT DTMES
                                   FROM DATA
                                  WHERE DTMES BETWEEN @P_DTMESINIC AND @P_DTMESFIM) DT    
      WHERE SE.CDFILIAL   = LS.CDFILIAL
        AND SE.CDSERVFILI = LS.CDSERVFILI
      ORDER BY SE.CDFILIAL, SE.CDSERVFILI, DT.DTMES
   OPEN C_SERVICO;
   
   FETCH NEXT FROM C_SERVICO INTO @V_CDFILIAL, @V_CDSERVFILI, @V_DTMES, @V_SER_CDDIETPAD;
                   
   WHILE (@@FETCH_STATUS = 0) BEGIN
    
      IF (@V_CDFILISERV <> @V_CDFILIAL+@V_CDSERVFILI) BEGIN
         SET @V_ROW = 0;
      END;
                                              
      SET @V_CONT = 0;
      SET @V_PAGINA = 1;
      
      /* SELECIONA AS CONFIGURAES DOS SERVIOS (TIPO DE PRATO) */    
      DECLARE C_CONFIG CURSOR FOR
         SELECT CF.CDFILIAL, CF.CDSERVFILI, CF.DTREFECNFMES, CF.NRSEQCNFMES,
                CF.NRORDCNFMES, CF.CDTIPOPRAT, CF.IDOPCCNFMES, TI.NMTIPOPRAT
          FROM CNFCAMES CF, TIPOPRAT TI
          WHERE CF.CDFILIAL     = @V_CDFILIAL
            AND CF.CDSERVFILI   = @V_CDSERVFILI
            AND CF.DTREFECNFMES = @V_DTMES
            AND CF.IDIMPCNFMES  = 'S'
            AND CF.CDTIPOPRAT   = TI.CDTIPOPRAT
          ORDER BY CF.NRORDCNFMES
      OPEN C_CONFIG;
      FETCH NEXT FROM C_CONFIG INTO @V_CONF_CDFILIAL, @V_CONF_CDSERVFILI, @V_DTREFECNFMES, @V_NRSEQCNFMES,
                                    @V_NRORDCNFMES,   @V_CDTIPOPRAT,      @V_IDOPCCNFMES,  @V_NMTIPOPRAT;                    
      
      WHILE (@@FETCH_STATUS = 0) BEGIN 
                                              
         SET @V_CONT = @V_CONT + 1;
          
         /* SELECIONA OS DIAS MS */ 
         DECLARE C_DATA CURSOR FOR(
            SELECT DTDATA, DTMES
            FROM DATA
            WHERE DTMES = @V_DTREFECNFMES)
         OPEN C_DATA;
         FETCH NEXT FROM C_DATA INTO @V_DTDATA, @V_DATA_DTMES; 
                              
         WHILE (@@FETCH_STATUS = 0) BEGIN  
          
          /* VERIFICA SE O PARAMETRO "IMPRIME NOME FANTASIA" ESTA MARCADA */                                        
          IF @P_IDNOMEFANT = 'S' BEGIN
                  SELECT @V_CDPRATO = MAX(CC.CDPRATO), @V_CDFILAUXPRAT = MAX(CC.CDFILAUXPRAT), @V_QTCOMENSAIS = MAX((CC.VRPECONSCARD * QTCOMESTICAR / 100)),
                         @V_VRPECONSCARD = MAX(CC.VRPECONSCARD), @V_NMPRATO = MAX(ISNULL(FA.NMPRATO, PT.NMPRATO)), @V_CDDIETPAD = MAX(CA.CDDIETPAD)
                  FROM CARDADIA CA, PRATO PT, COMPCARD CC LEFT JOIN                         
                      (SELECT NMFANTASIASE AS NMPRATO, CDPRATO, CDFILAUXPRAT
                       FROM PRATSERV
                       WHERE CDFILIAL   = @V_CONF_CDFILIAL
                         AND CDSERVFILI = @V_CONF_CDSERVFILI
                         AND NOT NMFANTASIASE IS NULL
                       UNION
                       SELECT P1.NMFANTASIAPF AS NMPRATO, P1.CDPRATO, P1.CDFILAUXPRAT
                       FROM PRATFILI P1
                       WHERE P1.CDFILIAL = @V_CONF_CDFILIAL
                         AND NOT P1.NMFANTASIAPF IS NULL
                         AND NOT EXISTS (SELECT P.NMFANTASIASE
                                         FROM PRATSERV P
                                         WHERE P.CDFILAUXPRAT = P1.CDFILAUXPRAT
                                           AND P.CDPRATO      = P1.CDPRATO
                                           AND P.CDFILIAL     = P1.CDFILIAL
                                           AND P.CDSERVFILI   = @V_CONF_CDSERVFILI
                                           AND NOT P.NMFANTASIASE IS NULL)
                       UNION
                       SELECT P2.NMFANTASIAPR AS NMPRATO, P2.CDPRATO, P2.CDFILAUXPRAT
                       FROM PRATPADR P2
                       WHERE NOT P2.NMFANTASIAPR IS NULL
                         AND NOT EXISTS (SELECT P.NMFANTASIASE
                                         FROM PRATSERV P
                                         WHERE P.CDFILAUXPRAT = P2.CDFILAUXPRAT
                                           AND P.CDPRATO      = P2.CDPRATO
                                           AND P.CDFILIAL     = @V_CONF_CDFILIAL
                                           AND P.CDSERVFILI   = @V_CONF_CDSERVFILI
                                           AND NOT P.NMFANTASIASE IS NULL)
                        AND NOT EXISTS (SELECT P.NMFANTASIAPF
                                        FROM PRATFILI P
                                        WHERE P.CDFILAUXPRAT = P2.CDFILAUXPRAT
                                          AND P.CDPRATO      = P2.CDPRATO
                                          AND P.CDFILIAL     = @V_CONF_CDFILIAL
                                          AND NOT P.NMFANTASIAPF IS NULL)) FA ON
                                                         FA.CDPRATO      = CC.CDPRATO
                                                         AND FA.CDFILAUXPRAT = CC.CDFILAUXPRAT 
                  WHERE CA.CDFILIAL     = @V_CONF_CDFILIAL
                    AND CA.CDSERVFILI   = @V_CONF_CDSERVFILI
                    AND ((CA.CDDIETPAD =  @V_SER_CDDIETPAD) OR (CA.CDDIETPAD IS NULL))
                    AND CA.DTCARDAPIO   = @V_DTDATA
                    AND CC.CDFILIAL     = CA.CDFILIAL
                    AND CC.NRCARDAPIO   = CA.NRCARDAPIO
                    AND CC.NRSEQPRATCAR = @V_NRSEQCNFMES
                    AND PT.CDPRATO      = CC.CDPRATO
                    AND PT.CDFILAUXPRAT = CC.CDFILAUXPRAT
          END
          ELSE
               BEGIN
                  SELECT @V_CDPRATO = MAX(CC.CDPRATO), @V_CDFILAUXPRAT = MAX(CC.CDFILAUXPRAT), @V_QTCOMENSAIS = MAX((CC.VRPECONSCARD * QTCOMESTICAR / 100)),
                         @V_VRPECONSCARD = MAX(CC.VRPECONSCARD), @V_NMPRATO = MAX(PT.NMPRATO), @V_CDDIETPAD = MAX(CA.CDDIETPAD)
                  FROM   CARDADIA CA, COMPCARD CC, PRATO PT
                  WHERE CA.CDFILIAL     = @V_CONF_CDFILIAL
                    AND CA.CDSERVFILI   = @V_CONF_CDSERVFILI
                    AND ((CA.CDDIETPAD =  @V_SER_CDDIETPAD) OR (CA.CDDIETPAD IS NULL))
                    AND CA.DTCARDAPIO   = @V_DTDATA
                    AND CC.CDFILIAL     = CA.CDFILIAL
                    AND CC.NRCARDAPIO   = CA.NRCARDAPIO
                    AND CC.NRSEQPRATCAR = @V_NRSEQCNFMES
                    AND PT.CDPRATO      = CC.CDPRATO
                    AND PT.CDFILAUXPRAT = CC.CDFILAUXPRAT;   
            END;

            IF @V_CONT = 1 BEGIN
               INSERT INTO TRABCARDMES(NRSEQTRABCARD, NRSEQUITEMTRAB, CDFILIAL, CDSERVFILI, NRSEQCARDMES, NRORDCARDMES,
                                       CDDIETPAD, DTCARDAPIO, DTMESCARD, IDOPCCNFMES1, CDTIPOPRAT1, NRPAGINA,
                                       CDPRATO1, CDFILAUXPRAT1, QTCOMENS1, VRPERCENT1, NMTIPOPRAT1, NMPRATO1)
               VALUES(@P_NRSEQTRABCARD, @V_ROW, @V_CONF_CDFILIAL, @V_CONF_CDSERVFILI, @V_NRSEQCNFMES, @V_NRORDCNFMES,
                      @V_SER_CDDIETPAD, @V_DTDATA, @V_DATA_DTMES, @V_IDOPCCNFMES, @V_CDTIPOPRAT, @V_PAGINA,
                      @V_CDPRATO, @V_CDFILAUXPRAT, @V_QTCOMENSAIS, @V_VRPECONSCARD, @V_NMTIPOPRAT, @V_NMPRATO);

               SET @V_ROW = @V_ROW + 1;

            END
            ELSE BEGIN
               UPDATE TRABCARDMES
               SET IDOPCCNFMES2   = CASE @V_CONT WHEN 2  THEN @V_IDOPCCNFMES ELSE IDOPCCNFMES2 END,
                   CDTIPOPRAT2    = CASE @V_CONT WHEN 2  THEN @V_CDTIPOPRAT ELSE CDTIPOPRAT2 END,
                   CDPRATO2       = CASE @V_CONT WHEN 2  THEN @V_CDPRATO ELSE CDPRATO2 END,
                   CDFILAUXPRAT2  = CASE @V_CONT WHEN 2  THEN @V_CDFILAUXPRAT ELSE CDFILAUXPRAT2 END,
                   QTCOMENS2      = CASE @V_CONT WHEN 2  THEN @V_QTCOMENSAIS ELSE QTCOMENS2 END,
                   VRPERCENT2     = CASE @V_CONT WHEN 2  THEN @V_VRPECONSCARD ELSE VRPERCENT2 END,
                   NMTIPOPRAT2    = CASE @V_CONT WHEN 2  THEN @V_NMTIPOPRAT ELSE NMTIPOPRAT2 END,
                   NMPRATO2       = CASE @V_CONT WHEN 2  THEN @V_NMPRATO ELSE NMPRATO2 END,
                   IDOPCCNFMES3   = CASE @V_CONT WHEN 3  THEN @V_IDOPCCNFMES ELSE IDOPCCNFMES3 END,
                   CDTIPOPRAT3    = CASE @V_CONT WHEN 3  THEN @V_CDTIPOPRAT ELSE CDTIPOPRAT3 END, 
                   CDPRATO3       = CASE @V_CONT WHEN 3  THEN @V_CDPRATO ELSE CDPRATO3 END,
                   CDFILAUXPRAT3  = CASE @V_CONT WHEN 3  THEN @V_CDFILAUXPRAT ELSE CDFILAUXPRAT3 END, 
                   QTCOMENS3      = CASE @V_CONT WHEN 3  THEN @V_QTCOMENSAIS ELSE QTCOMENS3 END,
                   VRPERCENT3     = CASE @V_CONT WHEN 3  THEN @V_VRPECONSCARD ELSE VRPERCENT3 END,
                   NMTIPOPRAT3    = CASE @V_CONT WHEN 3  THEN @V_NMTIPOPRAT ELSE NMTIPOPRAT3 END, 
                   NMPRATO3       = CASE @V_CONT WHEN 3  THEN @V_NMPRATO ELSE NMPRATO3 END,                     
                   IDOPCCNFMES4   = CASE @V_CONT WHEN 4  THEN @V_IDOPCCNFMES ELSE IDOPCCNFMES4 END,
                   CDTIPOPRAT4    = CASE @V_CONT WHEN 4  THEN @V_CDTIPOPRAT ELSE CDTIPOPRAT4 END,
                   CDPRATO4       = CASE @V_CONT WHEN 4  THEN @V_CDPRATO ELSE CDPRATO4 END, 
                   CDFILAUXPRAT4  = CASE @V_CONT WHEN 4  THEN @V_CDFILAUXPRAT ELSE CDFILAUXPRAT4 END,
                   QTCOMENS4      = CASE @V_CONT WHEN 4  THEN @V_QTCOMENSAIS ELSE QTCOMENS4 END,
                   VRPERCENT4     = CASE @V_CONT WHEN 4  THEN @V_VRPECONSCARD ELSE VRPERCENT4 END,
                   NMTIPOPRAT4    = CASE @V_CONT WHEN 4  THEN @V_NMTIPOPRAT ELSE NMTIPOPRAT4 END,
                   NMPRATO4       = CASE @V_CONT WHEN 4  THEN @V_NMPRATO ELSE NMPRATO4 END,
                   IDOPCCNFMES5   = CASE @V_CONT WHEN 5  THEN @V_IDOPCCNFMES ELSE IDOPCCNFMES5 END,
                   CDTIPOPRAT5    = CASE @V_CONT WHEN 5  THEN @V_CDTIPOPRAT ELSE CDTIPOPRAT5 END,
                   CDPRATO5       = CASE @V_CONT WHEN 5  THEN @V_CDPRATO ELSE CDPRATO5 END, 
                   CDFILAUXPRAT5  = CASE @V_CONT WHEN 5  THEN @V_CDFILAUXPRAT ELSE CDFILAUXPRAT5 END,
                   QTCOMENS5      = CASE @V_CONT WHEN 5  THEN @V_QTCOMENSAIS ELSE QTCOMENS5 END,
                   VRPERCENT5     = CASE @V_CONT WHEN 5  THEN @V_VRPECONSCARD ELSE VRPERCENT5 END,
                   NMTIPOPRAT5    = CASE @V_CONT WHEN 5  THEN @V_NMTIPOPRAT ELSE NMTIPOPRAT5 END,
                   NMPRATO5       = CASE @V_CONT WHEN 5  THEN @V_NMPRATO ELSE NMPRATO5 END,
                   IDOPCCNFMES6   = CASE @V_CONT WHEN 6  THEN @V_IDOPCCNFMES ELSE IDOPCCNFMES6 END,
                   CDTIPOPRAT6    = CASE @V_CONT WHEN 6  THEN @V_CDTIPOPRAT ELSE CDTIPOPRAT6 END,
                   CDPRATO6       = CASE @V_CONT WHEN 6  THEN @V_CDPRATO ELSE CDPRATO6 END, 
                   CDFILAUXPRAT6  = CASE @V_CONT WHEN 6  THEN @V_CDFILAUXPRAT ELSE CDFILAUXPRAT6 END,
                   QTCOMENS6      = CASE @V_CONT WHEN 6  THEN @V_QTCOMENSAIS ELSE QTCOMENS6 END,
                   VRPERCENT6     = CASE @V_CONT WHEN 6  THEN @V_VRPECONSCARD ELSE VRPERCENT6 END,
                   NMTIPOPRAT6    = CASE @V_CONT WHEN 6  THEN @V_NMTIPOPRAT ELSE NMTIPOPRAT6 END,
                   NMPRATO6       = CASE @V_CONT WHEN 6  THEN @V_NMPRATO ELSE NMPRATO6 END,
                   IDOPCCNFMES7   = CASE @V_CONT WHEN 7  THEN @V_IDOPCCNFMES ELSE IDOPCCNFMES7 END,
                   CDTIPOPRAT7    = CASE @V_CONT WHEN 7  THEN @V_CDTIPOPRAT ELSE CDTIPOPRAT7 END,
                   CDPRATO7       = CASE @V_CONT WHEN 7  THEN @V_CDPRATO ELSE CDPRATO7 END, 
                   CDFILAUXPRAT7  = CASE @V_CONT WHEN 7  THEN @V_CDFILAUXPRAT ELSE CDFILAUXPRAT7 END,
                   QTCOMENS7      = CASE @V_CONT WHEN 7  THEN @V_QTCOMENSAIS ELSE QTCOMENS7 END,
                   VRPERCENT7     = CASE @V_CONT WHEN 7  THEN @V_VRPECONSCARD ELSE VRPERCENT7 END,
                   NMTIPOPRAT7    = CASE @V_CONT WHEN 7  THEN @V_NMTIPOPRAT ELSE NMTIPOPRAT7 END,
                   NMPRATO7       = CASE @V_CONT WHEN 7  THEN @V_NMPRATO ELSE NMPRATO7 END,
                   IDOPCCNFMES8   = CASE @V_CONT WHEN 8  THEN @V_IDOPCCNFMES ELSE IDOPCCNFMES8 END,
                   CDTIPOPRAT8    = CASE @V_CONT WHEN 8  THEN @V_CDTIPOPRAT ELSE CDTIPOPRAT8 END,
                   CDPRATO8       = CASE @V_CONT WHEN 8  THEN @V_CDPRATO ELSE CDPRATO8 END, 
                   CDFILAUXPRAT8  = CASE @V_CONT WHEN 8  THEN @V_CDFILAUXPRAT ELSE CDFILAUXPRAT8 END,
                   QTCOMENS8      = CASE @V_CONT WHEN 8  THEN @V_QTCOMENSAIS ELSE QTCOMENS8 END,
                   VRPERCENT8     = CASE @V_CONT WHEN 8  THEN @V_VRPECONSCARD ELSE VRPERCENT8 END,
                   NMTIPOPRAT8    = CASE @V_CONT WHEN 8  THEN @V_NMTIPOPRAT ELSE NMTIPOPRAT8 END,
                   NMPRATO8       = CASE @V_CONT WHEN 8  THEN @V_NMPRATO ELSE NMPRATO8 END,
                   IDOPCCNFMES9   = CASE @V_CONT WHEN 9  THEN @V_IDOPCCNFMES ELSE IDOPCCNFMES9 END,
                   CDTIPOPRAT9    = CASE @V_CONT WHEN 9  THEN @V_CDTIPOPRAT ELSE CDTIPOPRAT9 END,
                   CDPRATO9       = CASE @V_CONT WHEN 9  THEN @V_CDPRATO ELSE CDPRATO9 END, 
                   CDFILAUXPRAT9  = CASE @V_CONT WHEN 9  THEN @V_CDFILAUXPRAT ELSE CDFILAUXPRAT9 END,
                   QTCOMENS9      = CASE @V_CONT WHEN 9  THEN @V_QTCOMENSAIS ELSE QTCOMENS9 END,
                   VRPERCENT9     = CASE @V_CONT WHEN 9  THEN @V_VRPECONSCARD ELSE VRPERCENT9 END,
                   NMTIPOPRAT9    = CASE @V_CONT WHEN 9  THEN @V_NMTIPOPRAT ELSE NMTIPOPRAT9 END,
                   NMPRATO9       = CASE @V_CONT WHEN 9  THEN @V_NMPRATO ELSE NMPRATO9 END,
                   IDOPCCNFMES10  = CASE @V_CONT WHEN 10 THEN @V_IDOPCCNFMES ELSE IDOPCCNFMES10 END,
                   CDTIPOPRAT10   = CASE @V_CONT WHEN 10 THEN @V_CDTIPOPRAT ELSE CDTIPOPRAT10 END,
                   CDPRATO10      = CASE @V_CONT WHEN 10 THEN @V_CDPRATO ELSE CDPRATO10 END, 
                   CDFILAUXPRAT10 = CASE @V_CONT WHEN 10 THEN @V_CDFILAUXPRAT ELSE CDFILAUXPRAT10 END,
                   QTCOMENS10     = CASE @V_CONT WHEN 10 THEN @V_QTCOMENSAIS ELSE QTCOMENS10 END,
                   VRPERCENT10    = CASE @V_CONT WHEN 10 THEN @V_VRPECONSCARD ELSE VRPERCENT10 END,
                   NMTIPOPRAT10   = CASE @V_CONT WHEN 10 THEN @V_NMTIPOPRAT ELSE NMTIPOPRAT10 END,
                   NMPRATO10      = CASE @V_CONT WHEN 10 THEN @V_NMPRATO ELSE NMPRATO10 END
               WHERE CDFILIAL    = @V_CONF_CDFILIAL
                 AND CDSERVFILI  = @V_CONF_CDSERVFILI
                 AND ((CDDIETPAD = @V_SER_CDDIETPAD) OR (CDDIETPAD IS NULL))
                 AND DTCARDAPIO  = @V_DTDATA
                 AND NRPAGINA    = @V_PAGINA;
            END;
         
         FETCH NEXT FROM C_DATA INTO @V_DTDATA, @V_DATA_DTMES;       

         END;
         CLOSE C_DATA;
         DEALLOCATE C_DATA;
                         
         IF @V_CONT = @P_QTCOLUNA BEGIN
            SET @V_CONT = 0;
            SET @V_PAGINA = @V_PAGINA + 1;
         END;
     
      FETCH NEXT FROM C_CONFIG INTO @V_CONF_CDFILIAL, @V_CONF_CDSERVFILI, @V_DTREFECNFMES, @V_NRSEQCNFMES,
                                    @V_NRORDCNFMES,   @V_CDTIPOPRAT,      @V_IDOPCCNFMES,  @V_NMTIPOPRAT;         

      END;
    
      CLOSE C_CONFIG;
      DEALLOCATE C_CONFIG;
                         
      SET @V_CDFILISERV = @V_CDFILIAL+@V_CDSERVFILI;                     

   FETCH NEXT FROM C_SERVICO INTO @V_CDFILIAL, @V_CDSERVFILI, @V_DTMES, @V_SER_CDDIETPAD;

   END; 
                       
   CLOSE C_SERVICO;
   DEALLOCATE C_SERVICO;;
                                        
   IF @P_IDIMPDIASSEM = 'N' BEGIN
      DELETE TRABCARDMES
      WHERE NRSEQTRABCARD = @P_NRSEQTRABCARD
        AND CDPRATO1  IS NULL
        AND CDPRATO2  IS NULL
        AND CDPRATO3  IS NULL
        AND CDPRATO4  IS NULL
        AND CDPRATO5  IS NULL
        AND CDPRATO6  IS NULL
        AND CDPRATO7  IS NULL
        AND CDPRATO8  IS NULL
        AND CDPRATO9  IS NULL
        AND CDPRATO10 IS NULL
   END;
                                    
END;
GO
GO