(function () {
	var ZeedhiDirectives = angular.module('ZeedhiDirectives');
	ZeedhiDirectives.directive('zhRichText', zhRichText);

	function zhRichText(templateManager, ZHPromise, $timeout) {
		return {
			restrict: 'A',
			require: '?ngModel',
			link: function(scope, element, attrs, controller) {
				function isEmptyText(text) {
					return text === "" || text == "<br>" || text == "<p><br></p>";
				}

				function setCursorPositionToEnd(node) {
					node.focus();
					var textNode = node.firstChild;
					var range = document.createRange();
					range.setStart(textNode, 1);
					range.setEnd(textNode, 1);
					var sel = window.getSelection();
					sel.removeAllRanges();
					sel.addRange(range);					
				}

				scope.onInitElement = function() {
					if (isEmptyText(element.summernote('code'))) {					
						var context = element.data('summernote');
						if (context && scope.field) {
							context.invoke('editor.fontSize', scope.field.defaultFontSize || 14);
							context.invoke('editor.fontName', scope.field.defaultFontName || "Arial");
							context.invoke('buttons.updateCurrentStyle');
						}
					} else {
						var editor = element.next().find('.note-editable')[0];
						var bogusCharPosition = editor.innerHTML.indexOf('\ufeff');
						if (bogusCharPosition !== -1) {
							editor.innerHTML = editor.innerHTML.slice(0,bogusCharPosition) + editor.innerHTML.slice(bogusCharPosition+1);

							setCursorPositionToEnd(editor);
						}
					}
				};

				if (controller) {
					controller.$parsers.unshift(function(value) {
						value = value.replace(/[\ufeff]/g,'').replace(/<p>/g,"<div>").replace(/<p /g,"<div ").replace(/<\/p>/g,"</div>");
						return value;
					});
				}
			}
		};
	}
})();